#pragma once

#include "resource.h"

class CAccessRights : 
	public CAxDialogImpl<CAccessRights>
{
public:
	CAccessRights() :
		m_UserEnabled (FALSE),
		m_pGroups (NULL),
		m_pUsers (NULL)
	{
	}

	enum { IDD = IDD_ACCESSRIGHTS };

BEGIN_MSG_MAP(CAccessRights)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_HANDLER(IDOK, BN_CLICKED, OnClickedOK)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnClickedCancel)
	CHAIN_MSG_MAP(CAxDialogImpl<CAccessRights>)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		CAxDialogImpl<CAccessRights>::OnInitDialog(uMsg, wParam, lParam, bHandled);

		// DLRWX
		CheckDlgButton (IDC_EXECUTE, (m_AC.rights & 1) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton (IDC_WRITE, (m_AC.rights & 2) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton (IDC_READ, (m_AC.rights & 4) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton (IDC_LIST, (m_AC.rights & 8) ? BST_CHECKED : BST_UNCHECKED);
		CheckDlgButton (IDC_DELETE, (m_AC.rights & 16) ? BST_CHECKED : BST_UNCHECKED);

		if (m_UserEnabled) {
			if (m_pGroups) {
				POSITION pos = m_pGroups->GetHeadPosition ();
				while (pos) {
					SendDlgItemMessage (IDC_USERS, CB_ADDSTRING, 0,
						reinterpret_cast <LPARAM> ((LPCTSTR) m_pGroups->GetNext (pos)));
				}
			}
			if (m_pUsers) {
				POSITION pos = m_pUsers->GetHeadPosition ();
				while (pos) {
					SendDlgItemMessage (IDC_USERS, CB_ADDSTRING, 0,
						reinterpret_cast <LPARAM> ((LPCTSTR) m_pUsers->GetNext (pos)));
				}
			}
		} else
			SendDlgItemMessage (IDC_USERS, CB_ADDSTRING, 0,
				reinterpret_cast <LPARAM> ((LPCTSTR) m_AC.subject));
		SendDlgItemMessage (IDC_USERS, CB_SETCURSEL, 0, 0);

		return 1;  // Let the system set the focus
	}

	LRESULT OnClickedOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		// DLRWX
		m_AC.rights =
			((IsDlgButtonChecked (IDC_EXECUTE) == BST_CHECKED) ? 1 : 0) |
			((IsDlgButtonChecked (IDC_WRITE) == BST_CHECKED) ? 2 : 0) |
			((IsDlgButtonChecked (IDC_READ) == BST_CHECKED) ? 4 : 0) |
			((IsDlgButtonChecked (IDC_LIST) == BST_CHECKED) ? 8 : 0) |
			((IsDlgButtonChecked (IDC_DELETE) == BST_CHECKED) ? 16 : 0);

		if (m_UserEnabled)
			GetDlgItemText (IDC_USERS, m_AC.subject);

		EndDialog(wID);
		return 0;
	}

	LRESULT OnClickedCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
	{
		EndDialog(wID);
		return 0;
	}

public:
	EAC m_AC;						//  
	BOOL m_UserEnabled;				//    
	CAtlStringList* m_pUsers;		//  
	CAtlStringList* m_pGroups;		//  
};


