#pragma once

#define STRICT
#define WINVER 0x0400
#define _WIN32_WINNT 0x0400
#define _WIN32_WINDOWS 0x0400
#define _WIN32_IE 0x0500
#define _WIN32_DCOM
#define _ATL_APARTMENT_THREADED
#define _ATL_NO_AUTOMATIC_NAMESPACE
#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS
#define _ATL_CSTRING_NO_CRT
#define _ATL_ALL_WARNINGS

#include <atlbase.h>
#include <atlcom.h>
#include <atlcoll.h>
#include <atlstr.h>
#include <atlhost.h>
#include <shlobj.h>
#include <tlhelp32.h>

#include "resource.h"

class DECLSPEC_UUID("DCC9AE2A-B39A-4979-86CA-337713D97BBE") EServ;
DEFINE_GUID(CLSID_EServ, 0xDCC9AE2AL, 0xB39A, 0x4979, 0x86, 0xCA, 0x33, 0x77, 0x13, 0xD9, 0x7B, 0xBE);
struct __declspec(uuid("0C6C4200-C589-11D0-999A-00C04FD655E1")) IShellIconOverlayIdentifier;

using namespace ATL;

class EAC // EServ Access Control
{
public:
	EAC () throw () : subject (_T("")), rights (0) {}
	EAC (const EAC& ac) throw () : subject (ac.subject), rights (ac.rights) {}
	EAC (LPCTSTR s, DWORD r) throw () : subject (s), rights (r) {}
	EAC& operator= (const EAC& ac) throw ()
	{
		subject = ac.subject;
		rights = ac.rights;
		return *this;
	}
	CString subject;
	DWORD rights;
};

typedef CAtlList <EAC> EACL; // EServ Access Control List

typedef CAtlList <CString> CAtlStringList;
